#
# unix_hangul.tcl --
#
# ؽƮ  Ʈ н ѱԷ ϵ ε Ѵ.
#

#
# -----------------  Text widget  ----------------------------
#
proc TextHangulCompose {aWIDGET ch} {
    set linepos [$aWIDGET index insert]
    regexp {([^.]*).([^.]*)} $linepos x line pos

    if {$pos > 0} {
        set Prev [$aWIDGET get $line.[expr $pos - 1]]
        $aWIDGET delete $line.[expr $pos - 1]

        tkTextInsert $aWIDGET [Romaji2Han $Prev $ch]
    } else {
        tkTextInsert $aWIDGET [Romaji2Han "" $ch];
    }
}

proc TextHangulBind {} {
    InitHanAutomata

    bind Text <Return> {
        tkTextInsert %W \n
        InitHanAutomata
    }

    bind Text <BackSpace> {
        if {[%W tag nextrange sel 1.0 end] != ""} {
            %W delete sel.first sel.last
        } elseif [%W compare insert != 1.0] {
            %W delete insert-1c
            %W see insert
        }
        InitHanAutomata
    }

    bind Text <Any-KeyPress> {
        if {"%A" != ""} {
            if [expr [expr [string compare %K "Shift_L"] == 0] || \
                    [expr [string compare %K "Shift_R"] == 0] ] {
            } else {
                tkTextInsert %W %A

                InitHanAutomata
            }
        }
    }   

    bind Text <1> {
        tkTextButton1 %W %x %y
        %W tag remove sel 0.0 end
        InitHanAutomata
    }

    bind Text <2> {
        if !$tk_strictMotif {
            %W scan mark %x %y
            set tkPriv(x) %x
            set tkPriv(y) %y
            set tkPriv(mouseMoved) 0
        }
        InitHanAutomata
    }

    bind Text <KeyPress-a> {TextHangulCompose %W %A}
    bind Text <KeyPress-b> {TextHangulCompose %W %A}
    bind Text <KeyPress-c> {TextHangulCompose %W %A}
    bind Text <KeyPress-d> {TextHangulCompose %W %A}
    bind Text <KeyPress-e> {TextHangulCompose %W %A}
    bind Text <KeyPress-f> {TextHangulCompose %W %A}
    bind Text <KeyPress-g> {TextHangulCompose %W %A}
    bind Text <KeyPress-h> {TextHangulCompose %W %A}
    bind Text <KeyPress-i> {TextHangulCompose %W %A}
    bind Text <KeyPress-j> {TextHangulCompose %W %A}
    bind Text <KeyPress-k> {TextHangulCompose %W %A}
    bind Text <KeyPress-l> {TextHangulCompose %W %A}
    bind Text <KeyPress-m> {TextHangulCompose %W %A}
    bind Text <KeyPress-n> {TextHangulCompose %W %A}
    bind Text <KeyPress-o> {TextHangulCompose %W %A}
    bind Text <KeyPress-p> {TextHangulCompose %W %A}
    bind Text <KeyPress-q> {TextHangulCompose %W %A}
    bind Text <KeyPress-r> {TextHangulCompose %W %A}
    bind Text <KeyPress-s> {TextHangulCompose %W %A}
    bind Text <KeyPress-t> {TextHangulCompose %W %A}
    bind Text <KeyPress-u> {TextHangulCompose %W %A}
    bind Text <KeyPress-v> {TextHangulCompose %W %A}
    bind Text <KeyPress-w> {TextHangulCompose %W %A}
    bind Text <KeyPress-x> {TextHangulCompose %W %A}
    bind Text <KeyPress-y> {TextHangulCompose %W %A}
    bind Text <KeyPress-z> {TextHangulCompose %W %A}

    bind Text <KeyPress-A> {TextHangulCompose %W %A}
    bind Text <KeyPress-B> {TextHangulCompose %W %A}
    bind Text <KeyPress-C> {TextHangulCompose %W %A}
    bind Text <KeyPress-D> {TextHangulCompose %W %A}
    bind Text <KeyPress-E> {TextHangulCompose %W %A}
    bind Text <KeyPress-F> {TextHangulCompose %W %A}
    bind Text <KeyPress-G> {TextHangulCompose %W %A}
    bind Text <KeyPress-H> {TextHangulCompose %W %A}
    bind Text <KeyPress-I> {TextHangulCompose %W %A}
    bind Text <KeyPress-J> {TextHangulCompose %W %A}
    bind Text <KeyPress-K> {TextHangulCompose %W %A}
    bind Text <KeyPress-L> {TextHangulCompose %W %A}
    bind Text <KeyPress-M> {TextHangulCompose %W %A}
    bind Text <KeyPress-N> {TextHangulCompose %W %A}
    bind Text <KeyPress-O> {TextHangulCompose %W %A}
    bind Text <KeyPress-P> {TextHangulCompose %W %A}
    bind Text <KeyPress-Q> {TextHangulCompose %W %A}
    bind Text <KeyPress-R> {TextHangulCompose %W %A}
    bind Text <KeyPress-S> {TextHangulCompose %W %A}
    bind Text <KeyPress-T> {TextHangulCompose %W %A}
    bind Text <KeyPress-U> {TextHangulCompose %W %A}
    bind Text <KeyPress-V> {TextHangulCompose %W %A}
    bind Text <KeyPress-W> {TextHangulCompose %W %A}
    bind Text <KeyPress-X> {TextHangulCompose %W %A}
    bind Text <KeyPress-Y> {TextHangulCompose %W %A}
    bind Text <KeyPress-Z> {TextHangulCompose %W %A}
}

proc TextHangulUnBind {} {
    bind Text <Return> {
        tkTextInsert %W \n
    }

    bind Text <BackSpace> {
        if {[%W tag nextrange sel 1.0 end] != ""} {
            %W delete sel.first sel.last
        } elseif [%W compare insert != 1.0] {
            %W delete insert-1c
            %W see insert
        }
    }

    bind Text <Any-KeyPress> {
        tkTextInsert %W %A
    }   

    bind Text <1> {
        tkTextButton1 %W %x %y
        %W tag remove sel 0.0 end
    }

    bind Text <2> {
        if !$tk_strictMotif {
            %W scan mark %x %y
            set tkPriv(x) %x
            set tkPriv(y) %y
            set tkPriv(mouseMoved) 0
        }
    }

    bind Text <KeyPress-a> {tkTextInsert %W %A}
    bind Text <KeyPress-b> {tkTextInsert %W %A}
    bind Text <KeyPress-c> {tkTextInsert %W %A}
    bind Text <KeyPress-d> {tkTextInsert %W %A}
    bind Text <KeyPress-e> {tkTextInsert %W %A}
    bind Text <KeyPress-f> {tkTextInsert %W %A}
    bind Text <KeyPress-g> {tkTextInsert %W %A}
    bind Text <KeyPress-h> {tkTextInsert %W %A}
    bind Text <KeyPress-i> {tkTextInsert %W %A}
    bind Text <KeyPress-j> {tkTextInsert %W %A}
    bind Text <KeyPress-k> {tkTextInsert %W %A}
    bind Text <KeyPress-l> {tkTextInsert %W %A}
    bind Text <KeyPress-m> {tkTextInsert %W %A}
    bind Text <KeyPress-n> {tkTextInsert %W %A}
    bind Text <KeyPress-o> {tkTextInsert %W %A}
    bind Text <KeyPress-p> {tkTextInsert %W %A}
    bind Text <KeyPress-q> {tkTextInsert %W %A}
    bind Text <KeyPress-r> {tkTextInsert %W %A}
    bind Text <KeyPress-s> {tkTextInsert %W %A}
    bind Text <KeyPress-t> {tkTextInsert %W %A}
    bind Text <KeyPress-u> {tkTextInsert %W %A}
    bind Text <KeyPress-v> {tkTextInsert %W %A}
    bind Text <KeyPress-w> {tkTextInsert %W %A}
    bind Text <KeyPress-x> {tkTextInsert %W %A}
    bind Text <KeyPress-y> {tkTextInsert %W %A}
    bind Text <KeyPress-z> {tkTextInsert %W %A}

    bind Text <KeyPress-A> {tkTextInsert %W %A}
    bind Text <KeyPress-B> {tkTextInsert %W %A}
    bind Text <KeyPress-C> {tkTextInsert %W %A}
    bind Text <KeyPress-D> {tkTextInsert %W %A}
    bind Text <KeyPress-E> {tkTextInsert %W %A}
    bind Text <KeyPress-F> {tkTextInsert %W %A}
    bind Text <KeyPress-G> {tkTextInsert %W %A}
    bind Text <KeyPress-H> {tkTextInsert %W %A}
    bind Text <KeyPress-I> {tkTextInsert %W %A}
    bind Text <KeyPress-J> {tkTextInsert %W %A}
    bind Text <KeyPress-K> {tkTextInsert %W %A}
    bind Text <KeyPress-L> {tkTextInsert %W %A}
    bind Text <KeyPress-M> {tkTextInsert %W %A}
    bind Text <KeyPress-N> {tkTextInsert %W %A}
    bind Text <KeyPress-O> {tkTextInsert %W %A}
    bind Text <KeyPress-P> {tkTextInsert %W %A}
    bind Text <KeyPress-Q> {tkTextInsert %W %A}
    bind Text <KeyPress-R> {tkTextInsert %W %A}
    bind Text <KeyPress-S> {tkTextInsert %W %A}
    bind Text <KeyPress-T> {tkTextInsert %W %A}
    bind Text <KeyPress-U> {tkTextInsert %W %A}
    bind Text <KeyPress-V> {tkTextInsert %W %A}
    bind Text <KeyPress-W> {tkTextInsert %W %A}
    bind Text <KeyPress-X> {tkTextInsert %W %A}
    bind Text <KeyPress-Y> {tkTextInsert %W %A}
    bind Text <KeyPress-Z> {tkTextInsert %W %A}
}

#
# -----------------  Entry widget  ----------------------------
#
proc EntryHangulCompose {aWIDGET ch} {
    set insertP [$aWIDGET index insert]

    if {$insertP > 0} {
        set Prev [kstring index [$aWIDGET get] [expr $insertP - 1]]
        $aWIDGET delete [expr $insertP - 1]
        tkEntryInsert $aWIDGET [Romaji2Han $Prev $ch]
    } else {
        tkEntryInsert $aWIDGET [Romaji2Han "" $ch]
    }
}

proc EntryHangulBind {} {
    InitHanAutomata

    bind Entry <1> {
        tkEntryButton1 %W %x
        %W selection clear

        InitHanAutomata
    }

    bind Entry <2> {
        if !$tk_strictMotif {
            %W scan mark %x
            set tkPriv(x) %x
            set tkPriv(y) %y
            set tkPriv(mouseMoved) 0
        }
        InitHanAutomata
    }

    bind Entry <BackSpace> {
        tkEntryBackspace %W
        InitHanAutomata
    }

    bind Entry <Any-KeyPress> {
        if [expr [expr [string compare %K "Shift_L"] == 0] || \
                [expr [string compare %K "Shift_R"] == 0]] {
        } else {
            tkEntryInsert %W %A
            InitHanAutomata
        }
    }   

    bind Entry <KeyPress-a> {EntryHangulCompose %W %A}
    bind Entry <KeyPress-b> {EntryHangulCompose %W %A}
    bind Entry <KeyPress-c> {EntryHangulCompose %W %A}
    bind Entry <KeyPress-d> {EntryHangulCompose %W %A}
    bind Entry <KeyPress-e> {EntryHangulCompose %W %A}
    bind Entry <KeyPress-f> {EntryHangulCompose %W %A}
    bind Entry <KeyPress-g> {EntryHangulCompose %W %A}
    bind Entry <KeyPress-h> {EntryHangulCompose %W %A}
    bind Entry <KeyPress-i> {EntryHangulCompose %W %A}
    bind Entry <KeyPress-j> {EntryHangulCompose %W %A}
    bind Entry <KeyPress-k> {EntryHangulCompose %W %A}
    bind Entry <KeyPress-l> {EntryHangulCompose %W %A}
    bind Entry <KeyPress-m> {EntryHangulCompose %W %A}
    bind Entry <KeyPress-n> {EntryHangulCompose %W %A}
    bind Entry <KeyPress-o> {EntryHangulCompose %W %A}
    bind Entry <KeyPress-p> {EntryHangulCompose %W %A}
    bind Entry <KeyPress-q> {EntryHangulCompose %W %A}
    bind Entry <KeyPress-r> {EntryHangulCompose %W %A}
    bind Entry <KeyPress-s> {EntryHangulCompose %W %A}
    bind Entry <KeyPress-t> {EntryHangulCompose %W %A}
    bind Entry <KeyPress-u> {EntryHangulCompose %W %A}
    bind Entry <KeyPress-v> {EntryHangulCompose %W %A}
    bind Entry <KeyPress-w> {EntryHangulCompose %W %A}
    bind Entry <KeyPress-x> {EntryHangulCompose %W %A}
    bind Entry <KeyPress-y> {EntryHangulCompose %W %A}
    bind Entry <KeyPress-z> {EntryHangulCompose %W %A}

    bind Entry <KeyPress-A> {EntryHangulCompose %W %A}
    bind Entry <KeyPress-B> {EntryHangulCompose %W %A}
    bind Entry <KeyPress-C> {EntryHangulCompose %W %A}
    bind Entry <KeyPress-D> {EntryHangulCompose %W %A}
    bind Entry <KeyPress-E> {EntryHangulCompose %W %A}
    bind Entry <KeyPress-F> {EntryHangulCompose %W %A}
    bind Entry <KeyPress-G> {EntryHangulCompose %W %A}
    bind Entry <KeyPress-H> {EntryHangulCompose %W %A}
    bind Entry <KeyPress-I> {EntryHangulCompose %W %A}
    bind Entry <KeyPress-J> {EntryHangulCompose %W %A}
    bind Entry <KeyPress-K> {EntryHangulCompose %W %A}
    bind Entry <KeyPress-L> {EntryHangulCompose %W %A}
    bind Entry <KeyPress-M> {EntryHangulCompose %W %A}
    bind Entry <KeyPress-N> {EntryHangulCompose %W %A}
    bind Entry <KeyPress-O> {EntryHangulCompose %W %A}
    bind Entry <KeyPress-P> {EntryHangulCompose %W %A}
    bind Entry <KeyPress-Q> {EntryHangulCompose %W %A}
    bind Entry <KeyPress-R> {EntryHangulCompose %W %A}
    bind Entry <KeyPress-S> {EntryHangulCompose %W %A}
    bind Entry <KeyPress-T> {EntryHangulCompose %W %A}
    bind Entry <KeyPress-U> {EntryHangulCompose %W %A}
    bind Entry <KeyPress-V> {EntryHangulCompose %W %A}
    bind Entry <KeyPress-W> {EntryHangulCompose %W %A}
    bind Entry <KeyPress-X> {EntryHangulCompose %W %A}
    bind Entry <KeyPress-Y> {EntryHangulCompose %W %A}
    bind Entry <KeyPress-Z> {EntryHangulCompose %W %A}
}

proc EntryHangulUnBind {} {
    bind Entry <BackSpace> {
        tkEntryBackspace %W
    }

    bind Entry <Any-KeyPress> {
        tkEntryInsert %W %A
    }   

    bind Entry <1> {
        tkEntryButton1 %W %x
        %W selection clear
    }

    bind Entry <2> {
        if !$tk_strictMotif {
            %W scan mark %x
            set tkPriv(x) %x
            set tkPriv(y) %y
            set tkPriv(mouseMoved) 0
        }
    }

    bind Entry <KeyPress-a> {tkEntryInsert %W %A}
    bind Entry <KeyPress-b> {tkEntryInsert %W %A}
    bind Entry <KeyPress-c> {tkEntryInsert %W %A}
    bind Entry <KeyPress-d> {tkEntryInsert %W %A}
    bind Entry <KeyPress-e> {tkEntryInsert %W %A}
    bind Entry <KeyPress-f> {tkEntryInsert %W %A}
    bind Entry <KeyPress-g> {tkEntryInsert %W %A}
    bind Entry <KeyPress-h> {tkEntryInsert %W %A}
    bind Entry <KeyPress-i> {tkEntryInsert %W %A}
    bind Entry <KeyPress-j> {tkEntryInsert %W %A}
    bind Entry <KeyPress-k> {tkEntryInsert %W %A}
    bind Entry <KeyPress-l> {tkEntryInsert %W %A}
    bind Entry <KeyPress-m> {tkEntryInsert %W %A}
    bind Entry <KeyPress-n> {tkEntryInsert %W %A}
    bind Entry <KeyPress-o> {tkEntryInsert %W %A}
    bind Entry <KeyPress-p> {tkEntryInsert %W %A}
    bind Entry <KeyPress-q> {tkEntryInsert %W %A}
    bind Entry <KeyPress-r> {tkEntryInsert %W %A}
    bind Entry <KeyPress-s> {tkEntryInsert %W %A}
    bind Entry <KeyPress-t> {tkEntryInsert %W %A}
    bind Entry <KeyPress-u> {tkEntryInsert %W %A}
    bind Entry <KeyPress-v> {tkEntryInsert %W %A}
    bind Entry <KeyPress-w> {tkEntryInsert %W %A}
    bind Entry <KeyPress-x> {tkEntryInsert %W %A}
    bind Entry <KeyPress-y> {tkEntryInsert %W %A}
    bind Entry <KeyPress-z> {tkEntryInsert %W %A}

    bind Entry <KeyPress-A> {tkEntryInsert %W %A}
    bind Entry <KeyPress-B> {tkEntryInsert %W %A}
    bind Entry <KeyPress-C> {tkEntryInsert %W %A}
    bind Entry <KeyPress-D> {tkEntryInsert %W %A}
    bind Entry <KeyPress-E> {tkEntryInsert %W %A}
    bind Entry <KeyPress-F> {tkEntryInsert %W %A}
    bind Entry <KeyPress-G> {tkEntryInsert %W %A}
    bind Entry <KeyPress-H> {tkEntryInsert %W %A}
    bind Entry <KeyPress-I> {tkEntryInsert %W %A}
    bind Entry <KeyPress-J> {tkEntryInsert %W %A}
    bind Entry <KeyPress-K> {tkEntryInsert %W %A}
    bind Entry <KeyPress-L> {tkEntryInsert %W %A}
    bind Entry <KeyPress-M> {tkEntryInsert %W %A}
    bind Entry <KeyPress-N> {tkEntryInsert %W %A}
    bind Entry <KeyPress-O> {tkEntryInsert %W %A}
    bind Entry <KeyPress-P> {tkEntryInsert %W %A}
    bind Entry <KeyPress-Q> {tkEntryInsert %W %A}
    bind Entry <KeyPress-R> {tkEntryInsert %W %A}
    bind Entry <KeyPress-S> {tkEntryInsert %W %A}
    bind Entry <KeyPress-T> {tkEntryInsert %W %A}
    bind Entry <KeyPress-U> {tkEntryInsert %W %A}
    bind Entry <KeyPress-V> {tkEntryInsert %W %A}
    bind Entry <KeyPress-W> {tkEntryInsert %W %A}
    bind Entry <KeyPress-X> {tkEntryInsert %W %A}
    bind Entry <KeyPress-Y> {tkEntryInsert %W %A}
    bind Entry <KeyPress-Z> {tkEntryInsert %W %A}
}

